<?php

namespace Modules\Store\Services;

use Illuminate\Http\Request;
use Modules\Store\Interfaces\StoreRepositoryInterface;
use Modules\Store\Models\Store;

class StoreService
{
    private StoreRepositoryInterface $storeRepository ;

    public function __construct(StoreRepositoryInterface $storeRepository)
    {
        $this->storeRepository = $storeRepository;
    }

    public function get(array $request = [])
    {
        $builder = $this->storeRepository->get($request);

        if (@$request['title'])
        {
            $builder->where('sd.title', 'LIKE', '%'.$request['title'].'%');
        }
        if (@$request['email'])
        {
            $builder->where('stores.email', $request['email']);
        }
        if (@$request['phone'])
        {
            $builder->where('stores.phone', $request['phone']);
        }
        if (@$request['date_from'])
        {
            $builder->whereDate('stores.created_at', '>=', $request['date_from']);
        }

        if (@$request['date_to'])
        {
            $builder->whereDate('stores.created_at', '<=', $request['date_to']);
        }

        if (isset($request['status']))
        {
            if (@$request['status'] == 0)
            {
                $builder->onlyTrashed();
            }
        }

        if (@$request['orderBy'])
        {
            $builder->orderBy($request['orderBy']['key'],$request['orderBy']['value']);
        }
        else
        {
            $builder->orderBy('id','DESC');
        }

        if (@$request['paginate']) {
            $stores= $builder->paginate(50);
        }else{
            $stores=$builder->cursor();
        }
        return $stores;
    }
    public function checkItem($id)
    {
        $store = $this->storeRepository->checkItem($id);
        return $store;
    }

    public function getItem($id)
    {
        $store = $this->checkItem($id);
        $storeDescription = $this->storeRepository->getItem($id);
        foreach ($storeDescription as $row) {
            $store[$row->local]= $row;
        }
        return $store;
    }

    public function getItemTrashed($id)
    {
        $store = $this->storeRepository->getItemTrashed($id);
        return $store;
    }

    public function create(array $request): Store
    {
        $store = $this->storeRepository->create($request);
        if (isset($request['brand_ids']))
        {
            $this->storeRepository->updateBrands($request,$store);
        }
        $this->storeRepository->saveData($request,$store->id);
        return $store;
    }
    public function update(array $request,int $id): Store
    {
        $store = $this->checkItem($id);

        if (isset($request['brand_ids']))
        {
            $this->storeRepository->updateBrands($request,$store);
        }

        $store = $this->storeRepository->update($request,$store);
        $this->storeRepository->saveData($request,$store->id);
        return $store;
    }
    public function destroy(int $id): void
    {
        $store = $this->checkItem($id);
        if ($store)
        {
            $this->storeRepository->destroy($store);
        }
        else
        {
            $store = $this->getItemTrashed($id);
            $this->storeRepository->restore($store);
        }
    }
    public function destroyAll(array $request): void
    {
        if ($request['status'] == 1)
        {
            $this->storeRepository->destroyAll($request['ids']);
        }
        else
        {
            $this->storeRepository->restoreAll($request['ids']);
        }
    }
}
